/***************************************************************************
 *   Copyright (C) 2005 by Xin Hu   *
 *      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "../fastsub.h"
#include "../const_def.h"
#include "../panel.h"
#include "../filament.h"
#include "../calcpForEikrOverR.h"
#include "../calcAEirkOverR.h"
#include "../calcaoneoverr.h"
#include "../calcaoneoverr.cpp"
#include "calcA_quadrature.h"
#include "calcP_quadrature.h"

int main()
{

  complex<double> k=sqrt((2*PI*1e10)*(2*PI*1e10)*MU0*3.9*EPI0);

  /*******************************************************************************
   //test_panel
  *********************************************************************************/
//   panel<complex<double> > p1 (point3D<complex<double> > (5e-6,0,0.0001825-4e-1*IMAG),
//                               point3D<complex<double> > (-5e-6,0,0.0001825-4e-1*IMAG),
//                               point3D<complex<double> > (-5e-6,0.003,0.0001825-4e-1*IMAG),
//                               point3D<complex<double> > (5e-6,0.003,0.0001825-4e-1*IMAG) );
//   panel<double> p2 (point3D<double> (5e-6,0,0.0001775+2.9e-2),
//                     point3D<double> (-5e-6,0,0.0001775+2.9e-2),
//                     point3D<double> (-5e-6,0.003,0.0001775+2.9e-2),
//                     point3D<double> (5e-6,0.003,0.0001775+2.9e-2) );
// 
//   //test \int_s 1/R dr'  R is real or complex
//   calcpForEikrOverR<complex<double>,double > calcp(k, false, true, 60);
//   complex<double> slp=0., dlp=0., zn=0.;
//   calcp(p1, p2.centroid(),slp, dlp,zn );
//   cout<<dlp<<endl;
//   
//     
//   calcPQuadrature<complex<double>,double > calcp_quad;
//   calcp_quad.init(k, 100);
//   dlp=0.;
//   calcp_quad(p1, p2.centroid(), dlp);
//   cout<<dlp<<endl;
  
  //test \int_s e^{-jkR}/R dr' R is real or complex


  /*******************************************************************************
   //test_filaments
  *********************************************************************************/
  filament<complex<double> > f1(point3D<complex<double> > (0.0, 0.0, -1e-6+1e-1*IMAG),
                                point3D<complex<double> > (0.0, 0.015, -1e-6+1e-1*IMAG),
                                2e-6, 2e-6, 5.8e7);
  filament<double > f2(point3D<double > (0.0,4e-2,  1e-6),
					   point3D<double > (0.015, 4e-2, 1e-6),
                       2e-6, 2e-6, 5.8e7);


  filament<complex<double> > f3(point3D<complex<double> > (0.0, 0.0, 0.),
                                point3D<complex<double> > (0.0, 0.015, 0.),
                                2e-6, 2e-6, 5.8e7);
  filament<double > f4(point3D<double > (1e-5, 0.0, 0.),
                       point3D<double > (1e-5, 0.015, 0.),
                       2e-6, 2e-6, 5.8e7);


  //compute \int_v \int_v 1/R dr'dr
//  calcAOneOverR calcA_static;
//   cout<<calcA_static.mutual(&f2,&f1)<<endl;
//   cout<<calcA_static.mutual(&f4,&f3)<<endl;
//  cout<<calcA_static.selfterm(&f2)<<" "<<endl;


  //test \int_v \int V e^{-jkr}/r dr'dr , \int_v \int V d/dx(e^{-jkR}/R) dr'dr and
  //\int_v \int V d/dy(e^{-jkR}/R) dr'dr
//    calcAEikrOverR<complex<double>, double > calcA;
//    calcA.init(k, false, true);
    complex<double> A=0., dIdx=0., dIdy=0.;
   //calcA(f1, f2, A, dIdx, dIdy);   
   //cout<<"hello"<<A<<" "<<dIdx<<" "<<dIdy<<endl;

   

//   calcAQuadrature<complex<double>, double > calcA_quad;
//   calcA_quad.init(k, true, true);
//   A=0., dIdx=0.;
//   complex<double> dIdy2=0.;
//       calcA_quad(f1, f2, A, dIdx, dIdy2);
//   cout<<"hello2"<<A<<" "<<dIdx<<" "<<dIdy2<<endl;
  
   calcAEikrOverR<double, double > calcA_s;
   calcA_s.init(k, true, false);
   calcA_s.selfterm(f4, A);
   cout<<A<<endl;
   
  calcAQuadrature<double, double > calcA_self;
  calcA_self.init(k, true, false);
  A=0.;
  calcA_self.selfterm(f4,A);
  cout<<A<<endl;
  
  
  
};
